@make(ais)
@aiInfo(topic=<Data can be appended to the end of an existing file>,
number=[AI-00278/06],
classcode=[ra],
statuscode=[WA],
mainref=[14.03.01@\(02)],
date=[89-06-16])
@aiHeading()
@begin(history)
@begin(toplines)
@mainref()
@standard[14.02@\(02)]
!class ramification 88-06-06
@cbon()!status WG9-approved 89-06-16@cboff()
@end(toplines)
!status ARG-approved 88-10-03 (reviewed)
!status ARG-approved (12-0-0) 88-06-06 (pending editorial review)
!status failed letter ballot (8+1-5-3) 88-06-06
!status ARG-approved 88-05-10 (reviewed; pending letter ballot)
!status ARG-approved (13-0-2) 87-09-15 (pending editorial review; ballot)
!status panel-approved (4-1-1) 87-09-15 (pending editorial review; ballot)
!status work-item 87-08-05
!status received 84-08-27
@references[!references AI-00320, AI-00357, @CommentNum[83-00401]83-00401]
@topic{!topic @cbon()Data can be appended to the end of an existing@cboff() file}
@end(history)

@subheading[!summary 88-10-03]

Data written to a text file or to a sequential file can be appended to the end
of an existing file.

@subheading[!question 87-10-29]

When a text file is opened for output via TEXT_@|IO, the column, line, and page
numbers are set to one.  Subsequent writing will overwrite the file.  There
seems to be no way to open an old file and go to the end of the file before
writing anything.  Can one append to an existing text file via TEXT_@|IO?
Similarly, can one append to a sequential or direct file?

@subheading[!response 88-10-03]

For text files, 14.3.1(2) says:
@begin(quotation)
For the procedures CREATE  and OPEN: @ellipsis()  After opening a  file
with mode  IN_@|FILE or  OUT_@|FILE,  the current  column,  current
line, and current page numbers are set to one.
@end(quotation)
14.1(1) says:
@begin(quotation)
An external file is identified by a string (the @i[name]).  A second
string (the @i[form]) gives further system-dependent characteristics
that may be associated with the file, such as the physical
organization or access rights.  The conventions governing the
interpretation of such strings must be documented in Appendix F.
@end(quotation)
The relation between (internal) file objects and external files is not
completely specified by the Standard.  AI-00320 says:
@begin(quotation)
For text files, line,  page, and column  numbers are properties
affected by read and write operations.  These are properties of
file objects: 14.1(2) says, @dq"In the  remainder of this Chapter,
the  term @i[file] is  always used to refer  to a file object;  the
term @i[external  file] is used  otherwise." 14.3.5(3)  says,  @dq"All
procedures  GET and PUT  maintain the current column, line, and
page numbers of the specified  file: @ellipsis()"  Since  the 14.3.5(3)
sentence  uses the  term @dq"file" instead  of  the term @dq"external
file," current numbers are not properties of the external file.
@end(quotation)
In particular, for text files, line, page, and column numbers are properties
of file objects, so line one, column one, and page one of an opened text file
need not be associated with the beginning of an external file.  Since
conventions for interpreting the @i[name] and @i[form] parameters of the OPEN
procedure are determined by the implementation, an implementation can
establish a convention whose effect is to associate line one, column one, and
page one with the end of an existing external file.  In such a case, PUT
operations will append text to the external file, and a RESET operation will
set the external file to the beginning of the appended part.

Similarly, a @i[form] or a @i[name] parameter can be used for appending to
sequential files, since 14.2(2) says:
@begin(quotation)
When [a sequential] file is opened, transfer starts from the beginning
of the file.
@end(quotation)
Since this statement refers to the beginning of an internal file object, and
since the relation between the @dq"beginning" of an internal file and the
beginning of an external file is implementation dependent, writing can begin
at the end of the external file.

Appending is not an issue for direct files, since the index for a direct file
can be set explicitly to any position (14.2.4(8-9)).

AI-00357 defines the effect of CLOSE and RESET on sequential files in the case
where the @i[form] or @i[name] parameters have not been used to achieve the
effect of appending.

